<ion-content>
  <ion-grid>
    <ion-row>
      <ion-col size-md="6" offset-md="3">
        <ion-card class="ion-padding">
          <form [formGroup]="form" (ngSubmit)="addLog()" method="post">
            <ion-grid>
              <ion-row>
                <ion-col>
                  <div padding align="center">
                    <ion-avatar>
                      <img [src]="visitor.profilePicture.content" />
                      <ion-fab vertical="center" horizontal="center">
                        <ion-fab-button size="small" (click)="takePicture()">
                          <ion-icon name="camera"></ion-icon>
                        </ion-fab-button>
                      </ion-fab>
                    </ion-avatar>
                  </div>
                </ion-col>
              </ion-row>
            </ion-grid>

            <ion-segment scrollable (ionChange)="segmentChanged($event)" color="secondary" value="RegularVisitorLog">
              <ion-segment-button value="RegularVisitorLog">
                <ion-label text-wrap>{{ 'Regular' | translate }}</ion-label>
              </ion-segment-button>
              <ion-segment-button value="DeliveryLog">
                <ion-label text-wrap>{{ 'Delivery' | translate }}</ion-label>
              </ion-segment-button>
              <ion-segment-button value="DailyVisitorLog">
                <ion-label text-wrap>{{ 'Daily' | translate }}</ion-label>
              </ion-segment-button>
            </ion-segment>

            <div *ngIf="logType === 'DailyVisitorLog'">
              <ion-item>
                <ion-label position="floating">{{ 'Unique Code' | translate }}</ion-label>
                <ion-input formControlName="uniqueCode" type="number"></ion-input>
              </ion-item>

              <div style="color: red;"
                *ngIf="form.get('uniqueCode').hasError('required') && form.get('uniqueCode').touched">
                {{ 'This field is required*' | translate }}
              </div>
            </div>

            <div *ngIf="logType === 'RegularVisitorLog' || logType === 'DeliveryLog'">
              <ion-item>
                <ion-label position="floating">{{ 'Visitor Mobile Number' | translate }}</ion-label>
                <ion-input formControlName="phone" type="number"></ion-input>
                <ion-fab-button slot="end" size="small" (click)="searchByMobile()" *ngIf="!form.get('phone').hasError('pattern')">
                  <ion-icon name="search"></ion-icon>
                </ion-fab-button>
              </ion-item>

              <div style="color: red;" *ngIf="form.get('phone').hasError('required') && form.get('phone').touched">
                {{ 'This field is required*' | translate }}
              </div>
              <div style="color: red;" *ngIf="form.get('phone').hasError('pattern') && form.get('phone').touched">
                {{ 'Please Enter valid phone number' | translate }}
              </div>

              <ion-item>
                <ion-label position="floating">{{ 'Visitor Name' | translate }}</ion-label>
                <ion-input formControlName="name" type="text"></ion-input>
              </ion-item>

              <div style="color: red;" *ngIf="form.get('name').hasError('required') && form.get('name').touched">
                {{ 'This field is required*' | translate }}
              </div>

              <ion-item>
                <ion-label position="floating">{{ 'Visitor Address' | translate }}</ion-label>
                <ion-textarea formControlName="address" type="text"></ion-textarea>
              </ion-item>

              <div style="color: red;" *ngIf="form.get('address').hasError('required') && form.get('address').touched">
                {{ 'This field is required*' | translate }}
              </div>

              <div *ngIf="logType === 'RegularVisitorLog'">
                <ion-item>
                  <ion-label position="floating">{{ 'Number of Accompanying
                    Visitors' | translate }}</ion-label>
                  <ion-input formControlName="noOfAccompanyingVisitors" type="number"></ion-input>
                </ion-item>

                <div style="color: red;"
                  *ngIf="form.get('noOfAccompanyingVisitors').hasError('required') && form.get('noOfAccompanyingVisitors').touched">
                  {{ 'This field is required*' | translate }}
                </div>

                <div style="color: red;"
                  *ngIf="form.get('noOfAccompanyingVisitors').hasError('pattern') && form.get('noOfAccompanyingVisitors').touched">
                  {{ 'Only single digit number is allowed' | translate }}
                </div>
              </div>

              <ion-item>
                <ion-label position="floating">{{ 'Visiting To' | translate }}</ion-label>
                <ionic-selectable #selectComponent formControlName="visitingTo" [items]="apartmentCache?.objects"
                  itemValueField="id" itemTextField="flatNo" itemTextField="phone" itemTextField="name"
                  [isMultiple]="false" headerColor="primary" [canSearch]="true" (onChange)="userChanged($event)"
                  (onSearch)="onSearch($event)" [shouldBackdropClose]="true" name="visitingTo" (onOpen)="onOpen()"
                  (onClose)="onClose()">
                  <ng-template ionicSelectableCloseButtonTemplate>
                    <ion-icon name="close-circle"></ion-icon>
                  </ng-template>

                  <ng-template ionicSelectableTitleTemplate>
                    {{ ' Select Visiting To' | translate }}
                  </ng-template>

                  <ng-template ionicSelectableItemTemplate let-apartment="item">
                    <ion-item>
                      <ion-icon name="home"></ion-icon>
                      <ion-label>{{ apartment.name }} ({{ apartment.facilityOwner?.name }})</ion-label>
                    </ion-item>
                  </ng-template>

                  <ng-template ionicSelectableFooterTemplate>
                    <ion-footer>
                      <ion-toolbar>
                        <ion-row text-center>
                          <ion-col>
                            <ion-button fill="clear" (click)="clear()">{{ 'Cancel' | translate }}</ion-button>
                          </ion-col>
                          <ion-col>
                            <ion-button fill="clear" (click)="confirm()">{{ 'Confirm' | translate }}</ion-button>
                          </ion-col>
                        </ion-row>
                      </ion-toolbar>
                    </ion-footer>
                  </ng-template>
                </ionic-selectable>
              </ion-item>

              <div style="color: red;"
                *ngIf="form.get('visitingTo').hasError('required') && form.get('visitingTo').touched">
                {{ 'This field is required*' | translate }} </div>

              <ion-item>
                <ion-label>{{ 'Contact Person' | translate }}</ion-label>
                <ion-select placeholder="{{ 'Select One' | translate }}" formControlName="contactPerson"
                  name="contactPerson">
                  <ion-select-option *ngFor="let subscriber of subscribers" [value]="subscriber">{{subscriber.name}}
                    ({{subscriber.residentType}})
                  </ion-select-option>
                  <ion-select-option *ngIf="subscribers?.length==0" disabled>
                    {{ 'This apartment is not having any
                    subscribers' | translate }}</ion-select-option>
                </ion-select>
              </ion-item>

              <div style="color: red;"
                *ngIf="form.get('visitingTo').hasError('required') && form.get('visitingTo').touched">
                {{ 'Select Visiting To field*' | translate }}
              </div>

              <div *ngIf="logType === 'RegularVisitorLog'">
                <ion-item>
                  <ion-label>{{ 'Vehicle Entry' | translate }}</ion-label>
                  <ion-toggle slot="start" formControlName="vehicleEntry" (ionChange)="vehicleEntryToggleChanged()">
                  </ion-toggle>
                </ion-item>

                <div *ngIf="vehicleEntry">
                  <ion-item>
                    <ion-label>{{ 'Visitor Vehicle Type' | translate }}</ion-label>
                    <ion-select placeholder="{{ 'Select One' | translate }}" formControlName="vehicleType"
                      name="vehicleType" (ionChange)="vehicleTypeChanged()">
                      <ion-select-option value="Two Wheeler">{{ 'Two Wheeler' | translate }}</ion-select-option>
                      <ion-select-option value="Four Wheeler">{{ 'Four Wheeler' | translate }}</ion-select-option>
                    </ion-select>
                  </ion-item>

                  <div style="color: red;"
                    *ngIf="form.get('vehicleType').hasError('required') && form.get('vehicleType').touched">
                    {{ 'This field is required*' | translate }}
                  </div>

                  <ion-item>
                    <ion-label position="floating">{{ 'Visitor Vehicle Number' | translate }}</ion-label>
                    <ion-input formControlName="vehicleNo" type="text" name="vehicleNo"
                      placeHolder="e.g. MH 12 AA 1234"></ion-input>
                  </ion-item>

                  <div style="color: red;"
                    *ngIf="form.get('vehicleNo').hasError('required') && form.get('vehicleNo').touched">
                    {{ 'This field is required*' | translate }}
                  </div>
                  <div style="color: red;"
                    *ngIf="form.get('vehicleNo').hasError('pattern') && form.get('vehicleNo').touched">
                    {{ 'Enter valid vehicle number' | translate }}
                  </div>

                  <ion-item>
                    <ion-label>{{ 'Select Parking' | translate }}</ion-label>
                    <ion-select placeholder="{{ 'Select One' | translate }}" formControlName="parking" name="parking">
                      <ion-select-option *ngFor="let parking of this.parkingCache?.objects" [value]="parking">
                        {{parking.name}}
                      </ion-select-option>
                      <ion-select-option *ngIf="this.parkingCache?.objects?.length==0" disabled>
                        {{ 'No Parking found' | translate }}</ion-select-option>
                    </ion-select>
                  </ion-item>

                  <div style="color: red;"
                    *ngIf="form.get('parking').hasError('required') && form.get('parking').touched">
                    {{ 'Select Parking field*' | translate }}
                  </div>
                </div>
              </div>

              <div *ngIf="logType === 'DeliveryLog'">
                <ion-item>
                  <ion-label position="floating">{{ 'Rack Number' | translate }}</ion-label>
                  <ion-input formControlName="rackNumber" type="text"></ion-input>
                </ion-item>
              </div>
            </div>
            <ion-button type="submit" expand="full" color="primary" [disabled]="!form.valid">
              {{ 'Create' | translate }}</ion-button>
          </form>
        </ion-card>
      </ion-col>
    </ion-row>
  </ion-grid>
  <div style="height: 100px;">&nbsp;</div>
</ion-content>